{
  "variables": {
    # x264_root as relative path to the module root
    "x264_root%": "<(module_root_dir)/x264"
  },
  "targets": [
    {
      "cflags!": [ "-fno-exceptions" ],
      "cflags_cc!": [ "-fno-exceptions" ],
      "include_dirs" : [
        "<!@(node -p \"require('node-addon-api').include\")"
      ],
      "link_settings": {
        "libraries": [
          "-lpam", # provided by libpam0g-dev or pam-devel based on OS
        ]
      },
      "target_name": "authentication-utility",
      "sources": [ 
        "native_src/authentication_module.cc",
        "native_src/authentication_module_pam.cc"
      ],
      # To avoid native node modules from throwing cpp exception and raise pending JS exception which can be handled in JS   
      "defines": [ 'NAPI_DISABLE_CPP_EXCEPTIONS' ]   
     },
     {
        "target_name": "daemonNativeEventsUtility",
        "cflags!": [ "-fno-exceptions" ],
        "cflags_cc!": [ "-fno-exceptions" ],
        "sources": [
          "native_src/DaemonNativeEventsCapturer.cc",
          "native_src/LoginStateEvents.cc",
          "native_src/KeyPressEvents.cc"
        ],
        'include_dirs': [ "<!@(node -p \"require('node-addon-api').include\")" ],
        'libraries': [ "-lsystemd" ],
        'dependencies': [ "<!(node -p \"require('node-addon-api').gyp\")" ],
        'defines': [ 'NAPI_DISABLE_CPP_EXCEPTIONS' ]
    }
  ]
}
