#ifndef LOGIN_STATE_EVENTS_CAPTURER_H_
#define LOGIN_STATE_EVENTS_CAPTURER_H_

#include <systemd/sd-login.h>
#include <napi.h>
#include <poll.h>
#include <assert.h>
#include <unistd.h>
#include <memory>
#include <thread>
#include <iostream>
#include <chrono>

#include "../constants/common.h"

using namespace std;
using namespace Napi;

namespace LoginEvents
{
    typedef struct {
        char session[10];
        char tty[10];
        char seat[10];
        char service[30];
        char type[20];
        char sessClass[20];
        char sessState[20];
    } UserSessionInfo;

    typedef struct {
        uid_t uid;
        char state[20];
        int numSessions;
        UserSessionInfo* userSessionInfo;
    } UserStateInfo;

    class LoginStateEvents {
        public:
            LoginStateEvents();
            ~LoginStateEvents();

            bool init();
            void deinit();

            int getNumUid();
            UserStateInfo* get_sd_user_details();
            UserStateInfo* getUserStateInfo(uid_t* pUid, int uidNum = -1);
            Napi::Array convertCppToJavaScript(Napi::Env env, UserStateInfo *userStateInfo, int uidNum = -1);
            Napi::Value getUsersStateLoginData(Napi::Env env);

        private:
            // Used for uid events (like switch user, logout user, new user login to OS)
            int _uidNum;
            struct pollfd _poll_fd[1];
            sd_login_monitor *_monitor;
    };
} // namespace DaemonNativeEvents

#endif // LOGIN_STATE_EVENTS_CAPTURER_H_
