#include "../headers/KeyPressEvents.h"

using namespace KeyboardEvents;

KeyPressEvents::KeyPressEvents() {
    this->deviceFound = false;
    strcpy(this->keyboardDevicePath, "/dev/input/");

    this->findDeviceForKeyboard();
}

void KeyPressEvents::findDeviceForKeyboard() {
    char output[50] = "";
    FILE *fp = popen("ls -lrt /dev/input/by-path/ | grep kbd | grep -o '[^ ]*$' | tr -d '\n'", "r");

    if (fp != NULL) {
        // while(fgets(output, sizeof(output), fp) != NULL)
        //     printf("%s", output);
        // pending: can add a check for NULL
        fgets(output, sizeof(output), fp);
        strcat(this->keyboardDevicePath, &output[3]);
        this->deviceFound = true;
    } else {
        cout << "Could not fetch input device handler\n";
        this->deviceFound = false;
    }
    pclose(fp);
}

bool KeyPressEvents::init() {
    if (this->deviceFound == false)
        return this->deviceFound;

    fd = open(this->keyboardDevicePath, O_RDWR | O_NONBLOCK);

    if (fd == -1) {
        cout << "Could not open input device handler: '" << this->keyboardDevicePath << "'\n";
        this->deviceFound = false;
    }

    return this->deviceFound;
}

bool KeyPressEvents::get_paste_event_details() {
    struct input_event ev;
    bool returnValue = false;

    while (-1 != read(this->fd, &ev, sizeof(struct input_event))) {
        if (ev.type == EV_KEY && ev.value != 2) {
            // cout << "\tkey with code: " << ev.code << " is: " << (ev.value == 0 ? "released" : "pressed") << endl;
            switch(ev.code) {
                case 29: 
                case 97: 
                    if(this->isKeyPressed == 1 && ev.value == 1) {
                        if (returnValue == false)
                            returnValue = true;
                    } 
                    this->isKeyPressed = ev.value;
                break;

                case 47: 
                    if(this->isKeyPressed == 1 && ev.value == 1) {
                        if (returnValue == false)
                            returnValue = true;
                    }
                break;
            }
        }
    }

    return returnValue;
}


void KeyPressEvents::deinit() {
    close(fd);
}

KeyPressEvents::~KeyPressEvents() {
}
