#include <napi.h>
#include <iostream>
#include "../headers/authentication_module_pam.h"
using namespace authenticating;

Napi::Boolean AuthenticateUser(const Napi::CallbackInfo &info)
{
    Napi::Env env = info.Env();
    std::unique_ptr<AuthenticationModulePam> authInfo = AuthenticationModulePam::Create();
    std::string login;
    std::string password;
    std::cout << "Authentication Module" << std::endl;
    if (info.Length() != 2)
    {
        std::cout << "Invalid count of arguments" << info.Length() << std::endl;
        return Napi::Boolean::New(env, false);
    }
    login = info[0].ToString().Utf8Value();
    password = info[1].ToString().Utf8Value();

    if(authInfo->Authentication(login, password) == 1) {
        //std::cout << "Authenticate with " << login << " - " << password << " through system" <<std::endl;
        return Napi::Boolean::New(env, true);
    }

    std::cout << "Authentication Failed!" << std::endl;
    return Napi::Boolean::New(env, false);
}

Napi::Object Init(Napi::Env env, Napi::Object exports)
{
    Napi::Object authenticationUtility = Napi::Object::New(env);

    authenticationUtility.Set(Napi::String::New(env, "authenticateUser"), Napi::Function::New(env, AuthenticateUser));

    exports.Set("AuthenticationUtility", authenticationUtility);
    
    return exports;
}

NODE_API_MODULE(authentication_module, Init);

