#include "../headers/authentication_module_pam.h"

namespace authenticating
{
    struct pam_response *reply;

    AuthenticationModulePam::AuthenticationModulePam()
    {
        // function constructor for auth info object
    }

    std::unique_ptr<AuthenticationModulePam> AuthenticationModulePam::Create()
    {
        return std::unique_ptr<AuthenticationModulePam>(new AuthenticationModulePam());
    }

    // function used to get user input
    int FunctionConversation(int num_msg, const struct pam_message **msg, struct pam_response **resp, void *appdata_ptr)
    {
        *resp = reply;
        return PAM_SUCCESS;
    }

    int AuthenticateSystem(std::string username, std::string password)
    {
        const struct pam_conv local_conversation = {FunctionConversation, NULL};
        pam_handle_t *local_auth_handle = NULL; // this gets set by pam_start

        const char *uname = username.c_str();
        const char *pass = password.c_str();

        int retval;
        retval = pam_start("sudo", uname, &local_conversation, &local_auth_handle);
        std::cout << "pam_start returned: " << retval << std::endl;

        if (retval != PAM_SUCCESS)
        {
            std::cout << "pam_start returned: " << retval << std::endl;
            return 0;
        }

        reply = (struct pam_response *)malloc(sizeof(struct pam_response));

        reply[0].resp = strdup(pass);
        reply[0].resp_retcode = 0;
        retval = pam_authenticate(local_auth_handle, 0);

        if (retval != PAM_SUCCESS)
        {
            if (retval == PAM_AUTH_ERR)
            {
                std::cout << "Authentication failure." << std::endl;
            }
            else
            {
                std::cout << "pam_authenticate returned " << retval << std::endl;
            }
            return 0;
        }

        std::cout << "Authenticated." << std::endl;
        retval = pam_end(local_auth_handle, retval);

        if (retval != PAM_SUCCESS)
        {
            std::cout << "pam_end returned" << std::endl;
            return 0;
        }

        return 1;
    }

    int AuthenticationModulePam::Authentication(std::string username, std::string password)
    {
        return AuthenticateSystem(username, password);
    }

} //namespace remoting