const { execSync } = require("child_process");
const os = require("os");

console.log(process.argv);
const compilerOption = process.argv[2] !== undefined ? process.argv[2] : "";
const applicationType = process.argv[3] !== undefined ? process.argv[3] : "";

try {
    if (applicationType === 'cli') {
        console.log(execSync('cp -v binding_tty.gyp binding.gyp; echo "Building for TTY"; echo "#define TTY" > headers/compile_time_macros.h').toString());
    } else {
        console.log(execSync('cp -v binding_x11.gyp binding.gyp; echo "Building for X11"; echo "           " > headers/compile_time_macros.h').toString());
    }

    // copy x264 files for older/new OS Distro or pi32/pi64 OS
    if (os.arch() === 'arm') {
        console.log(execSync(`rm -rf x264; cp -rv x264-pi32 x264`).toString());
    } else if (os.arch() === 'arm64') {
        console.log(execSync(`rm -rf x264; cp -rv x264-pi64 x264`).toString());
    } else if (compilerOption === 'new-os') {
        console.log(execSync(`rm -rf x264; cp -rv x264-latest x264`).toString());
    } else {
        console.log(execSync(`rm -rf x264; cp -rv x264-cent7 x264`).toString());
    }
} catch (err) {
    console.log(`copying x264 failed. ${err}`);
    console.log(execSync(`ls -ltr`).toString());
}
