"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.xKeyboardModule = exports.ttyKeyboardUtility = exports.lockUtility = exports.screenCaptureUtility = exports.displayUtility = void 0;
const bindings_1 = __importDefault(require("bindings"));
const lock_system_1 = __importDefault(require("lock-system"));
/**
 * DisplayUtility will retrieve the information about the desktop display.
 * ScreenCaptureUtility will provide functions to capture screen and encode it.
 * Both these utilities are exposed by single .node file display-utility.node
 */
// tslint:disable-next-line: no-any
const addon = bindings_1.default('display-utility');
// tslint:disable: no-unsafe-any
exports.displayUtility = addon.DisplayUtility;
// Creating and exporting persistent object for screen capture utility
exports.screenCaptureUtility = new addon.ScreenCaptureUtility();
// tslint:enable: no-unsafe-any
exports.lockUtility = {
    lockScreen: lock_system_1.default
};
/**
 * KeyboardUtility will have functions related to keyboard input.
 * This utility is exposed by another .node file keyboard-utility.node
 */
// tslint:disable: no-any no-unsafe-any
const ttyKeyboardAddon = bindings_1.default('tty-keyboard-utility');
exports.ttyKeyboardUtility = ttyKeyboardAddon.TTYKeyboardUtility;
const keyboardModuleAddOn = (process.env.APP === 'remotepc-cli') ? bindings_1.default('tty-keyboard-utility') : bindings_1.default('keyboard-module');
exports.xKeyboardModule = (process.env.APP === 'remotepc-cli') ? ttyKeyboardAddon.TTYKeyboardUtility
    : new keyboardModuleAddOn.XKeyboardInfo();
//# sourceMappingURL=index.js.map