/// <reference types="node" />
import fs from 'fs';
import { IFileSystemExplorerOptions, IFIleSystemTree, IFSInfo, IFSNewInfo, IFSOperationResponse } from './constants';
export declare class FileSystemExplorer {
    constructor();
    createFileSystemTree(rootPathToDir: string, options?: IFileSystemExplorerOptions, onEachFile?: Function, onEachDirectory?: Function): IFIleSystemTree | undefined;
    getFileDetails(localPathToDir: string, rootPathInfo: IFIleSystemTree, rootPathStats: fs.Stats, onEachFile?: Function, fileType?: number): IFIleSystemTree | undefined;
    getDirectoriesAndFiles(localPathToDir: string, rootPathInfo: IFIleSystemTree, rootPathStats: fs.Stats, options?: IFileSystemExplorerOptions, onEachFile?: Function, onEachDirectory?: Function): IFIleSystemTree | undefined;
    getDateFormatMMDDYYYY(date: Date): string;
    getAllDirectoryPathFromFileSystem(rootPathToDir: string, options?: IFileSystemExplorerOptions, onEachFile?: Function, onEachDirectory?: Function): string[];
    getAllDirectoryPathFromPreparedFSInfo(fileSystemListInfo: IFIleSystemTree): string[];
    getAllFilePathFromFileSystem(rootPathToDir: string, options?: IFileSystemExplorerOptions, onEachFile?: Function, onEachDirectory?: Function): string[];
    getAllFilePathFromPreparedFSInfo(fileSystemListInfo: IFIleSystemTree): string[];
    getAllFSElementsDetailsFromFileSystem(rootPathToDir: string, options?: IFileSystemExplorerOptions, onEachFile?: Function, onEachDirectory?: Function): IFSInfo[];
    getAllFSElementsDetailsFromPreparedFSInfo(fileSystemListInfo: IFIleSystemTree): IFSInfo[];
    getDirectoryContentList(pathToDir: string, options?: IFileSystemExplorerOptions, onEachDirContent?: Function): IFSInfo[];
    getDirectoryContentListForJSON(pathToDir: string, options?: IFileSystemExplorerOptions, onEachDirContent?: Function): IFSNewInfo[];
    checkForPathAndFindTime(pathToUse?: string): string;
    createDirectory(destinationPath: string, isNewDirectoryNameIncluded?: boolean, isRecursive?: boolean): IFSOperationResponse;
    deleteDirectory(destinationPath: string, isDirectory?: boolean): IFSOperationResponse;
    renameFile(oldPath: string, newPath: string): IFSOperationResponse;
    checkDirectoryReadWritePersmission(pathToDir: string, mode?: number): number;
    checkFSElementExists(pathFSElement: string): boolean;
    getFSElementDetails(fsElementPath: string): IFSInfo;
    checkMountFreeSpace(pathToFSElement: string): string;
    normalizePath(absolutePath: string): string;
    private safeReadDirSync;
    private isRegEx;
}
//# sourceMappingURL=FileSystemExplorer.d.ts.map