export declare const FS_OK: number;
export declare const FS_ERR: number;
export interface IFSOperationResponse {
    errno: number;
    completePath: string;
    fileName: string;
}
export interface IRenameFileDetails {
    old_path_length: number;
    old_path: string;
    new_path_length: number;
    new_path: string;
}
export declare enum FILE_TYPE {
    FILE = 0,
    DIRECTORY = 1,
    SYMB_LINK = 2,
    DUMMY = 3,
    DRIVE = 4
}
export interface IFileSystemExplorerOptions {
    extensions?: RegExp;
    exclude?: RegExp | RegExp[];
    normalizePath?: boolean;
    resolveSymbolicLinks?: boolean;
    maxNumberOfFiles?: number;
}
export interface IFIleSystemTree {
    size: number;
    path: string;
    name: string;
    type: FILE_TYPE;
    mtime: Date;
    atime: Date;
    ctime: Date;
    childCount?: number;
    children?: IFIleSystemTree[];
    extension?: string;
}
export interface IFSInfo {
    size: number;
    name: string;
    type: number;
    mtime: string;
    extension?: string;
    path?: string;
    childCount?: number;
}
export interface IFSNewInfo {
    lsize: string;
    m_name: string;
    nType: number;
    m_lmd: string;
    extension?: string;
    m_FullPath?: string;
    childCount?: number;
}
//# sourceMappingURL=constants.d.ts.map