{
  "variables": {
    # x264_root as relative path to the module root
    "p2p_root%": "<(module_root_dir)/lib"
  },
  "targets": [
    { 
      "cflags!": [ "-fno-exceptions" ],
      "cflags": [ "-I/usr/include/dbus-1.0 -I/usr/lib/x86_64-linux-gnu/dbus-1.0/include" ],
      # "cflags": [ "-I/usr/include/dbus-1.0 -I/usr/lib64/dbus-1.0/include/" ],
      "cflags_cc!": [ "-fno-exceptions" ],
      "include_dirs" : [
        "<!@(node -p \"require('node-addon-api').include\")"
      ],
      "link_settings": {
        "libraries": [
          "-lX11", # provided by libx11-dev
          "-lXrandr", # provided by libxrandr-dev
          "-lXfixes",
          "-ldbus-1"
        ]
      },
      "target_name": "suiteNativeEventsCapturer",
      "sources": [
        "native_src/ClipboardEvents.cc",
        "native_src/CursorChangeEvents.cc",
        "native_src/ScreenLockSignal.cc",
        "native_src/SuiteNativeEventsCapturer.cc",
        "native_src/ScreenResEvents.cc",
        "native_src/DisplayUtility.cc",
        "native_src/OutputResolution.cc",
        "native_src/ScreenResources.cc",
        "native_src/OutputResolutionWithOffset.cc",
      ],
      # To avoid native node modules from throwing cpp exception and raise pending JS exception which can be handled in JS
      'dependencies': [ "<!(node -p \"require('node-addon-api').gyp\")" ],
      "defines": [ 'NAPI_DISABLE_CPP_EXCEPTIONS' ]
    },
    { 
      "cflags!": [ "-fno-exceptions" ],
      "cflags_cc!": [ "-fno-exceptions" ],
      "include_dirs" : [
        "<!@(node -p \"require('node-addon-api').include\")"
      ],
      "link_settings": {
        "libraries": [
          "-lpthread",
          "<@(p2p_root)/p2p-linux.a" # static library exported with the package
        ]
      },
      "target_name": "quicp2p",
      "sources": [ 
        "native_src/peer2peer.cc", 
      ],
      # To avoid native node modules from throwing cpp exception and raise pending JS exception which can be handled in JS
      'dependencies': [ "<!(node -p \"require('node-addon-api').gyp\")" ],
      "defines": [ 'NAPI_DISABLE_CPP_EXCEPTIONS' ]
    },
  ]
}
