const { execSync } = require("child_process");
const os = require("os");

console.log(process.argv);
const compilerOption = process.argv[2] !== undefined ? process.argv[2] : ""; 
const applicationType = process.argv[3] !== undefined ? process.argv[3] : "";

try {
    if (applicationType === 'cli') {
        console.log(execSync('cp -v binding_tty.gyp binding.gyp; echo "Building for TTY"').toString());
    } else {
        console.log(execSync('cp -v binding_x11.gyp binding.gyp; echo "Building for X11"').toString());
    }

    if (os.arch() === 'arm') {
        console.log(execSync(`rm -rf lib; cp -rv lib-pi32 lib`).toString());
    } else if (os.arch() === 'arm64') {
        console.log(execSync(`rm -rf lib; cp -rv lib-pi64 lib`).toString());
    } else {
        console.log(execSync(`rm -rf lib; cp -rv lib-x86 lib`).toString());
    }
} catch (err) {
    console.log(`copying lib failed. ${err}`);
    console.log(execSync(`ls -la`).toString());
}
