"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QUIC_P2P_EVENTS = exports.ICE_CANDIDATE_STATE = exports.quicPeer2PeerWrapper = exports.suiteNativeEventsCapturer = exports.quicP2PAddOn = exports.addon = void 0;
const bindings_1 = __importDefault(require("bindings"));
/**
 * DisplayUtility will retrieve the information about the desktop display.
 * ScreenCaptureUtility will provide functions to capture screen and encode it.
 * Both these utilities are exposed by single .node file display-utility.node
 */
// tslint:disable: no-any
exports.addon = (process.env.APP === 'remotepc-cli') ? bindings_1.default('quicp2p') : bindings_1.default('suiteNativeEventsCapturer');
exports.quicP2PAddOn = bindings_1.default('quicp2p');
// tslint:enable: no-any
// tslint:disable: no-unsafe-any
exports.suiteNativeEventsCapturer = (process.env.APP === 'remotepc-cli') ? new exports.addon.Peer2PeerWrapper()
    : new exports.addon.SuiteNativeEventsCapturer();
exports.quicPeer2PeerWrapper = new exports.quicP2PAddOn.Peer2PeerWrapper();
var ICE_CANDIDATE_STATE;
(function (ICE_CANDIDATE_STATE) {
    ICE_CANDIDATE_STATE[ICE_CANDIDATE_STATE["NEW"] = 1] = "NEW";
    ICE_CANDIDATE_STATE[ICE_CANDIDATE_STATE["CHECKING"] = 2] = "CHECKING";
    ICE_CANDIDATE_STATE[ICE_CANDIDATE_STATE["CONNECTED"] = 3] = "CONNECTED";
    ICE_CANDIDATE_STATE[ICE_CANDIDATE_STATE["COMPLETED"] = 4] = "COMPLETED";
    ICE_CANDIDATE_STATE[ICE_CANDIDATE_STATE["FAILED"] = 5] = "FAILED";
    ICE_CANDIDATE_STATE[ICE_CANDIDATE_STATE["DISCONNECTED"] = 6] = "DISCONNECTED";
    ICE_CANDIDATE_STATE[ICE_CANDIDATE_STATE["CLOSED"] = 7] = "CLOSED";
    ICE_CANDIDATE_STATE[ICE_CANDIDATE_STATE["INVALID"] = 8] = "INVALID";
    ICE_CANDIDATE_STATE[ICE_CANDIDATE_STATE["OTHER"] = 9] = "OTHER";
})(ICE_CANDIDATE_STATE = exports.ICE_CANDIDATE_STATE || (exports.ICE_CANDIDATE_STATE = {}));
var QUIC_P2P_EVENTS;
(function (QUIC_P2P_EVENTS) {
    QUIC_P2P_EVENTS["PRE_SWITCH_P2P"] = "pre-switch-p2p";
    QUIC_P2P_EVENTS["SWITCH_TO_P2P"] = "switch-to-p2p";
    QUIC_P2P_EVENTS["REINIT_ON_PINGPONG_FAIL"] = "reinit-on-pingpong-fail";
    QUIC_P2P_EVENTS["QUIC_MESSAGE_RECEIVED"] = "quic-message-received";
    QUIC_P2P_EVENTS["QUIC_LOCAL_PAIR_INFO"] = "quic-local-pair-info";
    QUIC_P2P_EVENTS["ICE_STATE_CHANGE"] = "ice-state-change";
})(QUIC_P2P_EVENTS = exports.QUIC_P2P_EVENTS || (exports.QUIC_P2P_EVENTS = {}));
//# sourceMappingURL=index.js.map